diff --git a/group/overview.php b/group/overview.php
old mode 100644
new mode 100755
index 64fff65..4022c64
--- a/group/overview.php
+++ b/group/overview.php
@@ -213,7 +213,7 @@ foreach ($members as $gpgid=>$groupdata) {
     echo html_writer::table($table);
     $printed = true;
 }
- }
+}
 if ($download == "ods" && has_capability('moodle/course:managegroups', $context)) {
     require_once("$CFG->libdir/odslib.class.php");
 
@@ -225,8 +225,7 @@ if ($download == "ods" && has_capability('moodle/course:managegroups', $context)
     $workbook->send($filename);
     /// Creating the first worksheet
     $myxls = & $workbook->add_worksheet($strresponses);
-
-     /// Print names of all the fields
+    /// Print names of all the fields
     $myxls->write_string(0, 0, get_string('grouping', 'group'));
     $myxls->write_string(0, 1, get_string("group"));
     $myxls->write_string(0, 2, get_string("idnumber"));
@@ -238,13 +237,13 @@ if ($download == "ods" && has_capability('moodle/course:managegroups', $context)
     /// generate the data for the body of the spreadsheet
     $row = 1;
     foreach ($members as $gpgid => $groupdata) {
-    
-            if ($gpgid < 0) {
-                $groupname = $strnotingrouping;
-            } else {
-                $groupname = format_string($groupings[$gpgid]->name);
-            }
-            // $row++;
+
+        if ($gpgid < 0) {
+            $groupname = $strnotingrouping;
+        } else {
+            $groupname = format_string($groupings[$gpgid]->name);
+        }
+        // $row++;
 
         if ($groupingid and $groupingid != $gpgid) {
             continue; // do not show
@@ -254,8 +253,7 @@ if ($download == "ods" && has_capability('moodle/course:managegroups', $context)
                 continue;
             }
             $name = format_string($groups[$gpid]->name);
-            // $myxls->write_string($row, 1, $name);
-            // $row++;
+
             foreach ($users as $user) {
                 $myxls->write_string($row, 0, $groupname);
                 $myxls->write_string($row, 1, $name);
@@ -304,11 +302,11 @@ if ($download == "xls" && has_capability('moodle/course:managegroups', $context)
     $row = 1;
     foreach ($members as $gpgid => $groupdata) {
         $groupname = '';
-            if ($gpgid < 0) {
-                $groupname = $strnotingrouping;
-            } else {
-                $groupname = format_string($groupings[$gpgid]->name);
-            }
+        if ($gpgid < 0) {
+            $groupname = $strnotingrouping;
+        } else {
+            $groupname = format_string($groupings[$gpgid]->name);
+        }
         if ($groupingid and $groupingid != $gpgid) {
             continue; // do not show
         }
@@ -317,8 +315,6 @@ if ($download == "xls" && has_capability('moodle/course:managegroups', $context)
                 continue;
             }
             $name = format_string($groups[$gpid]->name);
- //          $myxls->write_string($row, 1, $name);
- //           $row++;
             foreach ($users as $user) {
                 $myxls->write_string($row, 0, $groupname);
                 $myxls->write_string($row, 1, $name);
@@ -336,7 +332,7 @@ if ($download == "xls" && has_capability('moodle/course:managegroups', $context)
 
     }
 
-/// Close the workbook
+    /// Close the workbook
     $workbook->close();
     exit;
 }
@@ -357,13 +353,13 @@ if ($download == "txt" && has_capability('moodle/course:managegroups', $context)
     echo get_string("firstname") . "\t" . get_string("lastname") . "\t" . "\n";
 
     foreach ($members as $gpgid => $groupdata) {
-       
-            if ($gpgid < 0) {
-                $grouping =  $strnotingrouping ;
-            } else {
-                $grouping =  format_string($groupings[$gpgid]->name);
-            }
-        
+         
+        if ($gpgid < 0) {
+            $grouping =  $strnotingrouping ;
+        } else {
+            $grouping =  format_string($groupings[$gpgid]->name);
+        }
+
         if ($groupingid and $groupingid != $gpgid) {
             continue; // do not show
         }
@@ -372,7 +368,7 @@ if ($download == "txt" && has_capability('moodle/course:managegroups', $context)
                 continue;
             }
             $name = format_string($groups[$gpid]->name);
-            // echo "\t". $name . "\n";
+
             foreach ($users as $user) {
                 echo $grouping . "\t";
                 echo $name . "\t";
@@ -386,7 +382,7 @@ if ($download == "txt" && has_capability('moodle/course:managegroups', $context)
         if ($groupid and empty($groupdata)) {
             continue;
         }
-        
+
     }
     exit;
 }
@@ -399,19 +395,17 @@ if (!empty($user) && has_capability('moodle/course:managegroups', $context)) {
     $options = array();
     $options["id"] = "$courseid";
     $options["download"] = "ods";
-     echo $OUTPUT->single_button(new moodle_url('overview.php', $options) , get_string("downloadods"));
+    echo $OUTPUT->single_button(new moodle_url('overview.php', $options) , get_string("downloadods"));
     echo "</td><td>";
     $options["download"] = "xls";
-     echo $OUTPUT->single_button(new moodle_url('overview.php', $options) , get_string("downloadexcel"));
+    echo $OUTPUT->single_button(new moodle_url('overview.php', $options) , get_string("downloadexcel"));
     echo "</td><td>";
     $options["download"] = "txt";
     echo $OUTPUT->single_button(new moodle_url('overview.php', $options) , get_string("downloadtext"));
-   
+     
     echo "</td></tr></table>";
 }
 
- 
- 
 if (count($hoverevents)>0) {
     $PAGE->requires->string_for_js('description', 'moodle');
     $PAGE->requires->js_init_call('M.core_group.init_hover_events', array($hoverevents));